/* ColorArea.c generated by valac 0.46.6, the Vala compiler
 * generated from ColorArea.vala, do not modify */

/*
* Copyright (c) 2017 Ronny Dobra (https://github.com/RonnyDo/ColorPicker)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Ronny Dobra <ronnydobra at arcor dot de>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define COLOR_PICKER_WIDGETS_TYPE_COLOR_AREA (color_picker_widgets_color_area_get_type ())
#define COLOR_PICKER_WIDGETS_COLOR_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), COLOR_PICKER_WIDGETS_TYPE_COLOR_AREA, ColorPickerWidgetsColorArea))
#define COLOR_PICKER_WIDGETS_COLOR_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), COLOR_PICKER_WIDGETS_TYPE_COLOR_AREA, ColorPickerWidgetsColorAreaClass))
#define COLOR_PICKER_WIDGETS_IS_COLOR_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COLOR_PICKER_WIDGETS_TYPE_COLOR_AREA))
#define COLOR_PICKER_WIDGETS_IS_COLOR_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), COLOR_PICKER_WIDGETS_TYPE_COLOR_AREA))
#define COLOR_PICKER_WIDGETS_COLOR_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), COLOR_PICKER_WIDGETS_TYPE_COLOR_AREA, ColorPickerWidgetsColorAreaClass))

typedef struct _ColorPickerWidgetsColorArea ColorPickerWidgetsColorArea;
typedef struct _ColorPickerWidgetsColorAreaClass ColorPickerWidgetsColorAreaClass;
typedef struct _ColorPickerWidgetsColorAreaPrivate ColorPickerWidgetsColorAreaPrivate;
enum  {
	COLOR_PICKER_WIDGETS_COLOR_AREA_0_PROPERTY,
	COLOR_PICKER_WIDGETS_COLOR_AREA_NUM_PROPERTIES
};
static GParamSpec* color_picker_widgets_color_area_properties[COLOR_PICKER_WIDGETS_COLOR_AREA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ColorPickerWidgetsColorArea {
	GtkDrawingArea parent_instance;
	ColorPickerWidgetsColorAreaPrivate * priv;
};

struct _ColorPickerWidgetsColorAreaClass {
	GtkDrawingAreaClass parent_class;
};

struct _ColorPickerWidgetsColorAreaPrivate {
	GdkRGBA color;
};

static gint ColorPickerWidgetsColorArea_private_offset;
static gpointer color_picker_widgets_color_area_parent_class = NULL;

GType color_picker_widgets_color_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ColorPickerWidgetsColorArea, g_object_unref)
ColorPickerWidgetsColorArea* color_picker_widgets_color_area_new (void);
ColorPickerWidgetsColorArea* color_picker_widgets_color_area_construct (GType object_type);
static gboolean color_picker_widgets_color_area_real_draw (GtkWidget* base,
                                                    cairo_t* ctx);
void color_picker_widgets_color_area_set_color (ColorPickerWidgetsColorArea* self,
                                                GdkRGBA* color);
static void color_picker_widgets_color_area_finalize (GObject * obj);

static inline gpointer
color_picker_widgets_color_area_get_instance_private (ColorPickerWidgetsColorArea* self)
{
	return G_STRUCT_MEMBER_P (self, ColorPickerWidgetsColorArea_private_offset);
}

ColorPickerWidgetsColorArea*
color_picker_widgets_color_area_construct (GType object_type)
{
	ColorPickerWidgetsColorArea * self = NULL;
	self = (ColorPickerWidgetsColorArea*) g_object_new (object_type, NULL);
	gtk_widget_set_size_request ((GtkWidget*) self, 140, 140);
	gdk_rgba_parse (&self->priv->color, "#EEEEEE");
	return self;
}

ColorPickerWidgetsColorArea*
color_picker_widgets_color_area_new (void)
{
	return color_picker_widgets_color_area_construct (COLOR_PICKER_WIDGETS_TYPE_COLOR_AREA);
}

static gboolean
color_picker_widgets_color_area_real_draw (GtkWidget* base,
                                           cairo_t* ctx)
{
	ColorPickerWidgetsColorArea * self;
	gint width = 0;
	gint height = 0;
	gdouble xc = 0.0;
	gdouble yc = 0.0;
	gdouble radius = 0.0;
	gdouble angle1 = 0.0;
	gdouble angle2 = 0.0;
	gint shadow_width = 0;
	gdouble shadow_alpha = 0.0;
	gchar* shadow_color = NULL;
	gchar* _tmp0_;
	GdkRGBA _tmp5_;
	gboolean result = FALSE;
	self = (ColorPickerWidgetsColorArea*) base;
	g_return_val_if_fail (ctx != NULL, FALSE);
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	xc = width / 2.0;
	yc = height / 2.0;
	radius = MIN (width, height) / 2.0;
	angle1 = (gdouble) 0;
	angle2 = 2 * G_PI;
	shadow_width = 6;
	shadow_alpha = 1.0;
	_tmp0_ = g_strdup ("#A9A9A9");
	shadow_color = _tmp0_;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GdkRGBA c = {0};
				const gchar* _tmp3_;
				GdkRGBA _tmp4_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i <= shadow_width)) {
					break;
				}
				cairo_arc (ctx, xc, yc, radius - i, angle1, angle2);
				memset (&c, 0, sizeof (GdkRGBA));
				_tmp3_ = shadow_color;
				gdk_rgba_parse (&c, _tmp3_);
				c.alpha = shadow_alpha / (((shadow_width - i) + 1) * ((shadow_width - i) + 1));
				_tmp4_ = c;
				gdk_cairo_set_source_rgba (ctx, &_tmp4_);
				cairo_stroke (ctx);
			}
		}
	}
	cairo_arc (ctx, xc, yc, radius - shadow_width, angle1, angle2);
	_tmp5_ = self->priv->color;
	gdk_cairo_set_source_rgba (ctx, &_tmp5_);
	cairo_fill (ctx);
	result = TRUE;
	_g_free0 (shadow_color);
	return result;
}

void
color_picker_widgets_color_area_set_color (ColorPickerWidgetsColorArea* self,
                                           GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (color != NULL);
	_tmp0_ = *color;
	self->priv->color = _tmp0_;
}

static void
color_picker_widgets_color_area_class_init (ColorPickerWidgetsColorAreaClass * klass,
                                            gpointer klass_data)
{
	color_picker_widgets_color_area_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ColorPickerWidgetsColorArea_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) color_picker_widgets_color_area_real_draw;
	G_OBJECT_CLASS (klass)->finalize = color_picker_widgets_color_area_finalize;
}

static void
color_picker_widgets_color_area_instance_init (ColorPickerWidgetsColorArea * self,
                                               gpointer klass)
{
	self->priv = color_picker_widgets_color_area_get_instance_private (self);
}

static void
color_picker_widgets_color_area_finalize (GObject * obj)
{
	ColorPickerWidgetsColorArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, COLOR_PICKER_WIDGETS_TYPE_COLOR_AREA, ColorPickerWidgetsColorArea);
	G_OBJECT_CLASS (color_picker_widgets_color_area_parent_class)->finalize (obj);
}

GType
color_picker_widgets_color_area_get_type (void)
{
	static volatile gsize color_picker_widgets_color_area_type_id__volatile = 0;
	if (g_once_init_enter (&color_picker_widgets_color_area_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ColorPickerWidgetsColorAreaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) color_picker_widgets_color_area_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ColorPickerWidgetsColorArea), 0, (GInstanceInitFunc) color_picker_widgets_color_area_instance_init, NULL };
		GType color_picker_widgets_color_area_type_id;
		color_picker_widgets_color_area_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ColorPickerWidgetsColorArea", &g_define_type_info, 0);
		ColorPickerWidgetsColorArea_private_offset = g_type_add_instance_private (color_picker_widgets_color_area_type_id, sizeof (ColorPickerWidgetsColorAreaPrivate));
		g_once_init_leave (&color_picker_widgets_color_area_type_id__volatile, color_picker_widgets_color_area_type_id);
	}
	return color_picker_widgets_color_area_type_id__volatile;
}

