/* Picker.c generated by valac 0.46.6, the Vala compiler
 * generated from Picker.vala, do not modify */

/*
* Copyright (c) 2017 Ronny Dobra (https://github.com/RonnyDo/ColorPicker)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Ronny Dobra <ronnydobra at arcor dot de>
* Inspired by: https://github.com/stuartlangridge/ColourPicker/
*/

#include <granite.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <string.h>
#include <stdlib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <stdio.h>

#define COLOR_PICKER_WIDGETS_TYPE_PICKER (color_picker_widgets_picker_get_type ())
#define COLOR_PICKER_WIDGETS_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), COLOR_PICKER_WIDGETS_TYPE_PICKER, ColorPickerWidgetsPicker))
#define COLOR_PICKER_WIDGETS_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), COLOR_PICKER_WIDGETS_TYPE_PICKER, ColorPickerWidgetsPickerClass))
#define COLOR_PICKER_WIDGETS_IS_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COLOR_PICKER_WIDGETS_TYPE_PICKER))
#define COLOR_PICKER_WIDGETS_IS_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), COLOR_PICKER_WIDGETS_TYPE_PICKER))
#define COLOR_PICKER_WIDGETS_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), COLOR_PICKER_WIDGETS_TYPE_PICKER, ColorPickerWidgetsPickerClass))

typedef struct _ColorPickerWidgetsPicker ColorPickerWidgetsPicker;
typedef struct _ColorPickerWidgetsPickerClass ColorPickerWidgetsPickerClass;
typedef struct _ColorPickerWidgetsPickerPrivate ColorPickerWidgetsPickerPrivate;
enum  {
	COLOR_PICKER_WIDGETS_PICKER_0_PROPERTY,
	COLOR_PICKER_WIDGETS_PICKER_NUM_PROPERTIES
};
static GParamSpec* color_picker_widgets_picker_properties[COLOR_PICKER_WIDGETS_PICKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define COLOR_PICKER_SERVICES_TYPE_SETTINGS (color_picker_services_settings_get_type ())
#define COLOR_PICKER_SERVICES_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), COLOR_PICKER_SERVICES_TYPE_SETTINGS, ColorPickerServicesSettings))
#define COLOR_PICKER_SERVICES_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), COLOR_PICKER_SERVICES_TYPE_SETTINGS, ColorPickerServicesSettingsClass))
#define COLOR_PICKER_SERVICES_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COLOR_PICKER_SERVICES_TYPE_SETTINGS))
#define COLOR_PICKER_SERVICES_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), COLOR_PICKER_SERVICES_TYPE_SETTINGS))
#define COLOR_PICKER_SERVICES_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), COLOR_PICKER_SERVICES_TYPE_SETTINGS, ColorPickerServicesSettingsClass))

typedef struct _ColorPickerServicesSettings ColorPickerServicesSettings;
typedef struct _ColorPickerServicesSettingsClass ColorPickerServicesSettingsClass;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	COLOR_PICKER_WIDGETS_PICKER_PICKED_SIGNAL,
	COLOR_PICKER_WIDGETS_PICKER_CANCELLED_SIGNAL,
	COLOR_PICKER_WIDGETS_PICKER_MOVED_SIGNAL,
	COLOR_PICKER_WIDGETS_PICKER_NUM_SIGNALS
};
static guint color_picker_widgets_picker_signals[COLOR_PICKER_WIDGETS_PICKER_NUM_SIGNALS] = {0};

struct _ColorPickerWidgetsPicker {
	GraniteWidgetsCompositedWindow parent_instance;
	ColorPickerWidgetsPickerPrivate * priv;
};

struct _ColorPickerWidgetsPickerClass {
	GraniteWidgetsCompositedWindowClass parent_class;
};

struct _ColorPickerWidgetsPickerPrivate {
	GdkRGBA dark_border_color;
	GdkRGBA bright_border_color;
	gint snapsize;
	gint min_zoomlevel;
	gint max_zoomlevel;
	gint zoomlevel;
	gint shadow_width;
	GdkCursor* magnifier;
};

static gint ColorPickerWidgetsPicker_private_offset;
static gpointer color_picker_widgets_picker_parent_class = NULL;
extern ColorPickerServicesSettings* color_picker_settings;

GType color_picker_widgets_picker_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ColorPickerWidgetsPicker, g_object_unref)
#define COLOR_PICKER_WIDGETS_PICKER_dark_border_color_string "#333333"
#define COLOR_PICKER_WIDGETS_PICKER_bright_border_color_string "#FFFFFF"
ColorPickerWidgetsPicker* color_picker_widgets_picker_new (void);
ColorPickerWidgetsPicker* color_picker_widgets_picker_construct (GType object_type);
GType color_picker_services_settings_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ColorPickerServicesSettings, g_object_unref)
gint color_picker_services_settings_get_zoomlevel (ColorPickerServicesSettings* self);
static gboolean color_picker_widgets_picker_real_button_release_event (GtkWidget* base,
                                                                GdkEventButton* e);
void color_picker_widgets_picker_get_color_at (ColorPickerWidgetsPicker* self,
                                               gint x,
                                               gint y,
                                               GdkRGBA* result);
static gboolean color_picker_widgets_picker_real_draw (GtkWidget* base,
                                                cairo_t* cr);
static gboolean color_picker_widgets_picker_real_motion_notify_event (GtkWidget* base,
                                                               GdkEventMotion* e);
void color_picker_widgets_picker_set_magnifier_cursor (ColorPickerWidgetsPicker* self);
static gboolean color_picker_widgets_picker_real_scroll_event (GtkWidget* base,
                                                        GdkEventScroll* e);
GdkPixbuf* color_picker_widgets_picker_snap (ColorPickerWidgetsPicker* self,
                                             gint x,
                                             gint y,
                                             gint w,
                                             gint h);
static gboolean color_picker_widgets_picker_real_key_press_event (GtkWidget* base,
                                                           GdkEventKey* e);
static void color_picker_widgets_picker_real_show_all (GtkWidget* base);
void color_picker_widgets_picker_close (ColorPickerWidgetsPicker* self);
void color_picker_services_settings_set_zoomlevel (ColorPickerServicesSettings* self,
                                                   gint value);
static GObject * color_picker_widgets_picker_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void color_picker_widgets_picker_finalize (GObject * obj);

static inline gpointer
color_picker_widgets_picker_get_instance_private (ColorPickerWidgetsPicker* self)
{
	return G_STRUCT_MEMBER_P (self, ColorPickerWidgetsPicker_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

ColorPickerWidgetsPicker*
color_picker_widgets_picker_construct (GType object_type)
{
	ColorPickerWidgetsPicker * self = NULL;
	gboolean _tmp0_ = FALSE;
	ColorPickerServicesSettings* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GdkScreen* screen = NULL;
	GdkScreen* _tmp10_;
	GdkScreen* _tmp11_;
	self = (ColorPickerWidgetsPicker*) granite_widgets_composited_window_construct (object_type);
	gtk_window_stick ((GtkWindow*) self);
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	gdk_rgba_parse (&self->priv->dark_border_color, COLOR_PICKER_WIDGETS_PICKER_dark_border_color_string);
	gdk_rgba_parse (&self->priv->bright_border_color, COLOR_PICKER_WIDGETS_PICKER_bright_border_color_string);
	_tmp1_ = color_picker_settings;
	_tmp2_ = color_picker_services_settings_get_zoomlevel (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ >= self->priv->min_zoomlevel) {
		ColorPickerServicesSettings* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		_tmp4_ = color_picker_settings;
		_tmp5_ = color_picker_services_settings_get_zoomlevel (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ <= self->priv->max_zoomlevel;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		ColorPickerServicesSettings* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		_tmp7_ = color_picker_settings;
		_tmp8_ = color_picker_services_settings_get_zoomlevel (_tmp7_);
		_tmp9_ = _tmp8_;
		self->priv->zoomlevel = _tmp9_;
	}
	_tmp10_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp11_ = _g_object_ref0 (_tmp10_);
	screen = _tmp11_;
	gtk_window_set_default_size ((GtkWindow*) self, gdk_screen_get_width (screen), gdk_screen_get_height (screen));
	_g_object_unref0 (screen);
	return self;
}

ColorPickerWidgetsPicker*
color_picker_widgets_picker_new (void)
{
	return color_picker_widgets_picker_construct (COLOR_PICKER_WIDGETS_TYPE_PICKER);
}

static gboolean
color_picker_widgets_picker_real_button_release_event (GtkWidget* base,
                                                       GdkEventButton* e)
{
	ColorPickerWidgetsPicker * self;
	gboolean result = FALSE;
	self = (ColorPickerWidgetsPicker*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->button == ((guint) 1)) {
		GdkRGBA color = {0};
		GdkRGBA _tmp0_ = {0};
		GdkRGBA _tmp1_;
		color_picker_widgets_picker_get_color_at (self, (gint) e->x_root, (gint) e->y_root, &_tmp0_);
		color = _tmp0_;
		_tmp1_ = color;
		g_signal_emit (self, color_picker_widgets_picker_signals[COLOR_PICKER_WIDGETS_PICKER_PICKED_SIGNAL], 0, &_tmp1_);
	} else {
		if (e->button == ((guint) 3)) {
			g_signal_emit (self, color_picker_widgets_picker_signals[COLOR_PICKER_WIDGETS_PICKER_CANCELLED_SIGNAL], 0);
		}
	}
	result = TRUE;
	return result;
}

static gboolean
color_picker_widgets_picker_real_draw (GtkWidget* base,
                                       cairo_t* cr)
{
	ColorPickerWidgetsPicker * self;
	gboolean result = FALSE;
	self = (ColorPickerWidgetsPicker*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	result = FALSE;
	return result;
}

static gboolean
color_picker_widgets_picker_real_motion_notify_event (GtkWidget* base,
                                                      GdkEventMotion* e)
{
	ColorPickerWidgetsPicker * self;
	GdkRGBA color = {0};
	GdkRGBA _tmp0_ = {0};
	GdkRGBA _tmp1_;
	gboolean result = FALSE;
	self = (ColorPickerWidgetsPicker*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	color_picker_widgets_picker_get_color_at (self, (gint) e->x_root, (gint) e->y_root, &_tmp0_);
	color = _tmp0_;
	_tmp1_ = color;
	g_signal_emit (self, color_picker_widgets_picker_signals[COLOR_PICKER_WIDGETS_PICKER_MOVED_SIGNAL], 0, &_tmp1_);
	color_picker_widgets_picker_set_magnifier_cursor (self);
	result = TRUE;
	return result;
}

static gboolean
color_picker_widgets_picker_real_scroll_event (GtkWidget* base,
                                               GdkEventScroll* e)
{
	ColorPickerWidgetsPicker * self;
	GdkScrollDirection _tmp0_;
	gboolean result = FALSE;
	self = (ColorPickerWidgetsPicker*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = e->direction;
	switch (_tmp0_) {
		case GDK_SCROLL_UP:
		{
			if (self->priv->zoomlevel < self->priv->max_zoomlevel) {
				gint _tmp1_;
				_tmp1_ = self->priv->zoomlevel;
				self->priv->zoomlevel = _tmp1_ + 1;
			}
			color_picker_widgets_picker_set_magnifier_cursor (self);
			break;
		}
		case GDK_SCROLL_DOWN:
		{
			if (self->priv->zoomlevel > self->priv->min_zoomlevel) {
				gint _tmp2_;
				_tmp2_ = self->priv->zoomlevel;
				self->priv->zoomlevel = _tmp2_ - 1;
			}
			color_picker_widgets_picker_set_magnifier_cursor (self);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}

void
color_picker_widgets_picker_set_magnifier_cursor (ColorPickerWidgetsPicker* self)
{
	gint px = 0;
	gint py = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint radius = 0;
	GdkPixbuf* latest_pb = NULL;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* scaled_pb = NULL;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	cairo_surface_t* base_surface = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* base_context = NULL;
	cairo_surface_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	GdkPixbuf* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	gdouble shadow_alpha = 0.0;
	cairo_t* _tmp15_;
	cairo_t* _tmp22_;
	GdkRGBA _tmp23_;
	cairo_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	GdkRGBA _tmp28_;
	cairo_t* _tmp29_;
	cairo_t* _tmp30_;
	cairo_t* _tmp31_;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_t* _tmp34_;
	cairo_t* _tmp35_;
	GdkRGBA _tmp36_;
	cairo_t* _tmp37_;
	cairo_t* _tmp38_;
	cairo_t* _tmp39_;
	cairo_t* _tmp40_;
	cairo_t* _tmp41_;
	cairo_t* _tmp42_;
	GdkPixbuf* drawn_pb = NULL;
	cairo_surface_t* _tmp43_;
	cairo_surface_t* _tmp44_;
	cairo_surface_t* _tmp45_;
	GdkPixbuf* _tmp46_;
	GdkScreen* _tmp47_;
	GdkDisplay* _tmp48_;
	GdkCursor* _tmp49_;
	GdkDeviceManager* manager = NULL;
	GdkDisplay* _tmp50_;
	GdkDeviceManager* _tmp51_;
	GdkDeviceManager* _tmp52_;
	GdkDevice* _tmp53_;
	GdkWindow* _tmp54_;
	GdkCursor* _tmp55_;
	g_return_if_fail (self != NULL);
	gtk_widget_get_pointer ((GtkWidget*) self, &_tmp0_, &_tmp1_);
	px = _tmp0_;
	py = _tmp1_;
	radius = (self->priv->snapsize * self->priv->zoomlevel) / 2;
	_tmp2_ = color_picker_widgets_picker_snap (self, px - (self->priv->snapsize / 2), py - (self->priv->snapsize / 2), self->priv->snapsize, self->priv->snapsize);
	latest_pb = _tmp2_;
	_tmp3_ = latest_pb;
	_tmp4_ = gdk_pixbuf_scale_simple (_tmp3_, (self->priv->snapsize * self->priv->zoomlevel) + (self->priv->shadow_width * 2), (self->priv->snapsize * self->priv->zoomlevel) + (self->priv->shadow_width * 2), GDK_INTERP_NEAREST);
	scaled_pb = _tmp4_;
	_tmp5_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, (self->priv->snapsize * self->priv->zoomlevel) + (self->priv->shadow_width * 2), (self->priv->snapsize * self->priv->zoomlevel) + (self->priv->shadow_width * 2));
	base_surface = _tmp5_;
	_tmp6_ = base_surface;
	_tmp7_ = cairo_create (_tmp6_);
	base_context = _tmp7_;
	_tmp8_ = base_context;
	cairo_arc (_tmp8_, (gdouble) (radius + self->priv->shadow_width), (gdouble) (radius + self->priv->shadow_width), (gdouble) radius, (gdouble) 0, 2 * G_PI);
	_tmp9_ = base_context;
	_tmp10_ = scaled_pb;
	gdk_cairo_set_source_pixbuf (_tmp9_, _tmp10_, (gdouble) 0, (gdouble) 0);
	_tmp11_ = base_context;
	cairo_save (_tmp11_);
	_tmp12_ = base_context;
	cairo_clip_preserve (_tmp12_);
	_tmp13_ = base_context;
	cairo_paint (_tmp13_);
	_tmp14_ = base_context;
	cairo_restore (_tmp14_);
	shadow_alpha = 0.6;
	_tmp15_ = base_context;
	cairo_set_line_width (_tmp15_, (gdouble) 1);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp16_ = FALSE;
			_tmp16_ = TRUE;
			while (TRUE) {
				cairo_t* _tmp18_;
				GdkRGBA shadow_color = {0};
				cairo_t* _tmp19_;
				GdkRGBA _tmp20_;
				cairo_t* _tmp21_;
				if (!_tmp16_) {
					gint _tmp17_;
					_tmp17_ = i;
					i = _tmp17_ + 1;
				}
				_tmp16_ = FALSE;
				if (!(i <= self->priv->shadow_width)) {
					break;
				}
				_tmp18_ = base_context;
				cairo_arc (_tmp18_, (gdouble) (radius + self->priv->shadow_width), (gdouble) (radius + self->priv->shadow_width), (gdouble) ((radius + self->priv->shadow_width) - i), (gdouble) 0, 2 * G_PI);
				memset (&shadow_color, 0, sizeof (GdkRGBA));
				gdk_rgba_parse (&shadow_color, COLOR_PICKER_WIDGETS_PICKER_dark_border_color_string);
				shadow_color.alpha = shadow_alpha / (((self->priv->shadow_width - i) + 1) * ((self->priv->shadow_width - i) + 1));
				_tmp19_ = base_context;
				_tmp20_ = shadow_color;
				gdk_cairo_set_source_rgba (_tmp19_, &_tmp20_);
				_tmp21_ = base_context;
				cairo_stroke (_tmp21_);
			}
		}
	}
	_tmp22_ = base_context;
	_tmp23_ = self->priv->bright_border_color;
	gdk_cairo_set_source_rgba (_tmp22_, &_tmp23_);
	_tmp24_ = base_context;
	cairo_arc (_tmp24_, (gdouble) (radius + self->priv->shadow_width), (gdouble) (radius + self->priv->shadow_width), (gdouble) (radius - 1), (gdouble) 0, 2 * G_PI);
	_tmp25_ = base_context;
	cairo_stroke (_tmp25_);
	_tmp26_ = base_context;
	cairo_set_line_width (_tmp26_, (gdouble) 1);
	_tmp27_ = base_context;
	_tmp28_ = self->priv->dark_border_color;
	gdk_cairo_set_source_rgba (_tmp27_, &_tmp28_);
	_tmp29_ = base_context;
	cairo_move_to (_tmp29_, (gdouble) ((radius + self->priv->shadow_width) - self->priv->zoomlevel), (gdouble) ((radius + self->priv->shadow_width) - self->priv->zoomlevel));
	_tmp30_ = base_context;
	cairo_line_to (_tmp30_, (gdouble) ((radius + self->priv->shadow_width) + self->priv->zoomlevel), (gdouble) ((radius + self->priv->shadow_width) - self->priv->zoomlevel));
	_tmp31_ = base_context;
	cairo_line_to (_tmp31_, (gdouble) ((radius + self->priv->shadow_width) + self->priv->zoomlevel), (gdouble) ((radius + self->priv->shadow_width) + self->priv->zoomlevel));
	_tmp32_ = base_context;
	cairo_line_to (_tmp32_, (gdouble) ((radius + self->priv->shadow_width) - self->priv->zoomlevel), (gdouble) ((radius + self->priv->shadow_width) + self->priv->zoomlevel));
	_tmp33_ = base_context;
	cairo_close_path (_tmp33_);
	_tmp34_ = base_context;
	cairo_stroke (_tmp34_);
	_tmp35_ = base_context;
	_tmp36_ = self->priv->bright_border_color;
	gdk_cairo_set_source_rgba (_tmp35_, &_tmp36_);
	_tmp37_ = base_context;
	cairo_move_to (_tmp37_, (gdouble) (((radius + self->priv->shadow_width) - self->priv->zoomlevel) + 1), (gdouble) (((radius + self->priv->shadow_width) - self->priv->zoomlevel) + 1));
	_tmp38_ = base_context;
	cairo_line_to (_tmp38_, (gdouble) (((radius + self->priv->shadow_width) + self->priv->zoomlevel) - 1), (gdouble) (((radius + self->priv->shadow_width) - self->priv->zoomlevel) + 1));
	_tmp39_ = base_context;
	cairo_line_to (_tmp39_, (gdouble) (((radius + self->priv->shadow_width) + self->priv->zoomlevel) - 1), (gdouble) (((radius + self->priv->shadow_width) + self->priv->zoomlevel) - 1));
	_tmp40_ = base_context;
	cairo_line_to (_tmp40_, (gdouble) (((radius + self->priv->shadow_width) - self->priv->zoomlevel) + 1), (gdouble) (((radius + self->priv->shadow_width) + self->priv->zoomlevel) - 1));
	_tmp41_ = base_context;
	cairo_close_path (_tmp41_);
	_tmp42_ = base_context;
	cairo_stroke (_tmp42_);
	_tmp43_ = base_surface;
	_tmp44_ = base_surface;
	_tmp45_ = base_surface;
	_tmp46_ = gdk_pixbuf_get_from_surface (_tmp43_, 0, 0, cairo_image_surface_get_width (_tmp44_), cairo_image_surface_get_height (_tmp45_));
	drawn_pb = _tmp46_;
	_tmp47_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp48_ = gdk_screen_get_display (_tmp47_);
	_tmp49_ = gdk_cursor_new_from_pixbuf (_tmp48_, drawn_pb, gdk_pixbuf_get_width (drawn_pb) / 2, gdk_pixbuf_get_height (drawn_pb) / 2);
	_g_object_unref0 (self->priv->magnifier);
	self->priv->magnifier = _tmp49_;
	_tmp50_ = gdk_display_get_default ();
	_tmp51_ = gdk_display_get_device_manager (_tmp50_);
	_tmp52_ = _g_object_ref0 (_tmp51_);
	manager = _tmp52_;
	_tmp53_ = gdk_device_manager_get_client_pointer (manager);
	_tmp54_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp55_ = self->priv->magnifier;
	gdk_device_grab (_tmp53_, _tmp54_, GDK_OWNERSHIP_APPLICATION, TRUE, (GDK_BUTTON_PRESS_MASK | GDK_POINTER_MOTION_MASK) | GDK_SCROLL_MASK, _tmp55_, (guint32) GDK_CURRENT_TIME);
	_g_object_unref0 (manager);
	_g_object_unref0 (drawn_pb);
	_cairo_destroy0 (base_context);
	_cairo_surface_destroy0 (base_surface);
	_g_object_unref0 (scaled_pb);
	_g_object_unref0 (latest_pb);
}

GdkPixbuf*
color_picker_widgets_picker_snap (ColorPickerWidgetsPicker* self,
                                  gint x,
                                  gint y,
                                  gint w,
                                  gint h)
{
	GdkWindow* root = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkPixbuf* screenshot = NULL;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gdk_get_default_root_window ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	root = _tmp1_;
	_tmp2_ = gdk_pixbuf_get_from_window (root, x, y, w, h);
	screenshot = _tmp2_;
	result = screenshot;
	_g_object_unref0 (root);
	return result;
}

static gboolean
color_picker_widgets_picker_real_key_press_event (GtkWidget* base,
                                                  GdkEventKey* e)
{
	ColorPickerWidgetsPicker * self;
	gboolean result = FALSE;
	self = (ColorPickerWidgetsPicker*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->keyval == GDK_KEY_Escape) {
		g_signal_emit (self, color_picker_widgets_picker_signals[COLOR_PICKER_WIDGETS_PICKER_CANCELLED_SIGNAL], 0);
	}
	result = TRUE;
	return result;
}

void
color_picker_widgets_picker_get_color_at (ColorPickerWidgetsPicker* self,
                                          gint x,
                                          gint y,
                                          GdkRGBA* result)
{
	GdkWindow* root = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkPixbuf* pixbuf = NULL;
	GdkWindow* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	FILE* _tmp34_;
	GdkRGBA _tmp35_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = gdk_get_default_root_window ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	root = _tmp1_;
	_tmp2_ = root;
	_tmp3_ = gdk_pixbuf_get_from_window (_tmp2_, x, y, 1, 1);
	pixbuf = _tmp3_;
	_tmp4_ = pixbuf;
	if (_tmp4_ != NULL) {
		guint8 red = 0U;
		GdkPixbuf* _tmp5_;
		guint8* _tmp6_;
		guint8 _tmp7_;
		guint8 green = 0U;
		GdkPixbuf* _tmp8_;
		guint8* _tmp9_;
		guint8 _tmp10_;
		guint8 blue = 0U;
		GdkPixbuf* _tmp11_;
		guint8* _tmp12_;
		guint8 _tmp13_;
		GdkRGBA color = {0};
		gchar* spec = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		const gchar* _tmp32_;
		_tmp5_ = pixbuf;
		_tmp6_ = gdk_pixbuf_get_pixels (_tmp5_);
		_tmp7_ = _tmp6_[0];
		red = _tmp7_;
		_tmp8_ = pixbuf;
		_tmp9_ = gdk_pixbuf_get_pixels (_tmp8_);
		_tmp10_ = _tmp9_[1];
		green = _tmp10_;
		_tmp11_ = pixbuf;
		_tmp12_ = gdk_pixbuf_get_pixels (_tmp11_);
		_tmp13_ = _tmp12_[2];
		blue = _tmp13_;
		memset (&color, 0, sizeof (GdkRGBA));
		_tmp14_ = g_strdup_printf ("%hhu", red);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat ("rgb(", _tmp15_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat (_tmp17_, ",", NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strdup_printf ("%hhu", green);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strconcat (_tmp19_, _tmp21_, NULL);
		_tmp23_ = _tmp22_;
		_tmp24_ = g_strconcat (_tmp23_, ",", NULL);
		_tmp25_ = _tmp24_;
		_tmp26_ = g_strdup_printf ("%hhu", blue);
		_tmp27_ = _tmp26_;
		_tmp28_ = g_strconcat (_tmp25_, _tmp27_, NULL);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_strconcat (_tmp29_, ")", NULL);
		_tmp31_ = _tmp30_;
		_g_free0 (_tmp29_);
		_g_free0 (_tmp27_);
		_g_free0 (_tmp25_);
		_g_free0 (_tmp23_);
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp15_);
		spec = _tmp31_;
		_tmp32_ = spec;
		if (gdk_rgba_parse (&color, _tmp32_)) {
			*result = color;
			_g_free0 (spec);
			_g_object_unref0 (pixbuf);
			_g_object_unref0 (root);
			return;
		} else {
			FILE* _tmp33_;
			_tmp33_ = stdout;
			fprintf (_tmp33_, "ERROR: Parse pixel rgb values failed.");
		}
		_g_free0 (spec);
	}
	_tmp34_ = stdout;
	fprintf (_tmp34_, "ERROR: Gdk.pixbuf_get_from_window failed");
	memset (&_tmp35_, 0, sizeof (GdkRGBA));
	*result = _tmp35_;
	_g_object_unref0 (pixbuf);
	_g_object_unref0 (root);
	return;
}

static void
color_picker_widgets_picker_real_show_all (GtkWidget* base)
{
	ColorPickerWidgetsPicker * self;
	GdkDeviceManager* manager = NULL;
	GdkDisplay* _tmp0_;
	GdkDeviceManager* _tmp1_;
	GdkDeviceManager* _tmp2_;
	GdkDevice* pointer = NULL;
	GdkDeviceManager* _tmp3_;
	GdkDevice* _tmp4_;
	GdkDevice* _tmp5_;
	GdkDevice* keyboard = NULL;
	GdkDevice* _tmp6_;
	GdkDevice* _tmp7_;
	GdkDevice* _tmp8_;
	GdkWindow* window = NULL;
	GdkWindow* _tmp9_;
	GdkWindow* _tmp10_;
	GdkGrabStatus status = 0;
	GdkDevice* _tmp11_;
	GdkWindow* _tmp12_;
	GdkWindow* _tmp13_;
	GdkDisplay* _tmp14_;
	GdkCursor* _tmp15_;
	GdkCursor* _tmp16_;
	GdkGrabStatus _tmp17_;
	GdkGrabStatus _tmp18_;
	GdkDevice* _tmp20_;
	self = (ColorPickerWidgetsPicker*) base;
	GTK_WIDGET_CLASS (color_picker_widgets_picker_parent_class)->show_all ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_WIDGETS_TYPE_COMPOSITED_WINDOW, GraniteWidgetsCompositedWindow));
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = gdk_display_get_device_manager (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	manager = _tmp2_;
	_tmp3_ = manager;
	_tmp4_ = gdk_device_manager_get_client_pointer (_tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	pointer = _tmp5_;
	_tmp6_ = pointer;
	_tmp7_ = gdk_device_get_associated_device (_tmp6_);
	_tmp8_ = _g_object_ref0 (_tmp7_);
	keyboard = _tmp8_;
	_tmp9_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp10_ = _g_object_ref0 (_tmp9_);
	window = _tmp10_;
	_tmp11_ = pointer;
	_tmp12_ = window;
	_tmp13_ = window;
	_tmp14_ = gdk_window_get_display (_tmp13_);
	_tmp15_ = gdk_cursor_new_for_display (_tmp14_, GDK_CROSSHAIR);
	_tmp16_ = _tmp15_;
	_tmp17_ = gdk_device_grab (_tmp11_, _tmp12_, GDK_OWNERSHIP_NONE, FALSE, (GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK) | GDK_POINTER_MOTION_MASK, _tmp16_, gtk_get_current_event_time ());
	_g_object_unref0 (_tmp16_);
	status = _tmp17_;
	_tmp18_ = status;
	if (_tmp18_ != GDK_GRAB_SUCCESS) {
		GdkDevice* _tmp19_;
		_tmp19_ = pointer;
		gdk_device_ungrab (_tmp19_, gtk_get_current_event_time ());
	}
	color_picker_widgets_picker_set_magnifier_cursor (self);
	_tmp20_ = keyboard;
	if (_tmp20_ != NULL) {
		GdkDevice* _tmp21_;
		GdkWindow* _tmp22_;
		GdkGrabStatus _tmp23_;
		_tmp21_ = keyboard;
		_tmp22_ = window;
		status = gdk_device_grab (_tmp21_, _tmp22_, GDK_OWNERSHIP_NONE, FALSE, GDK_KEY_PRESS_MASK, NULL, gtk_get_current_event_time ());
		_tmp23_ = status;
		if (_tmp23_ != GDK_GRAB_SUCCESS) {
			GdkDevice* _tmp24_;
			_tmp24_ = keyboard;
			gdk_device_ungrab (_tmp24_, gtk_get_current_event_time ());
		}
	}
	_g_object_unref0 (window);
	_g_object_unref0 (keyboard);
	_g_object_unref0 (pointer);
	_g_object_unref0 (manager);
}

void
color_picker_widgets_picker_close (ColorPickerWidgetsPicker* self)
{
	ColorPickerServicesSettings* _tmp0_;
	GdkWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = color_picker_settings;
	color_picker_services_settings_set_zoomlevel (_tmp0_, self->priv->zoomlevel);
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
	gdk_window_set_cursor (_tmp1_, NULL);
	gtk_window_close ((GtkWindow*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_WIDGETS_TYPE_COMPOSITED_WINDOW, GraniteWidgetsCompositedWindow));
}

static GObject *
color_picker_widgets_picker_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ColorPickerWidgetsPicker * self;
	parent_class = G_OBJECT_CLASS (color_picker_widgets_picker_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, COLOR_PICKER_WIDGETS_TYPE_PICKER, ColorPickerWidgetsPicker);
	g_object_set ((GtkWindow*) self, "type", GTK_WINDOW_POPUP, NULL);
	return obj;
}

static void
color_picker_widgets_picker_class_init (ColorPickerWidgetsPickerClass * klass,
                                        gpointer klass_data)
{
	color_picker_widgets_picker_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ColorPickerWidgetsPicker_private_offset);
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) color_picker_widgets_picker_real_button_release_event;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) color_picker_widgets_picker_real_draw;
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) color_picker_widgets_picker_real_motion_notify_event;
	((GtkWidgetClass *) klass)->scroll_event = (gboolean (*) (GtkWidget*, GdkEventScroll*)) color_picker_widgets_picker_real_scroll_event;
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) color_picker_widgets_picker_real_key_press_event;
	((GtkWidgetClass *) klass)->show_all = (void (*) (GtkWidget*)) color_picker_widgets_picker_real_show_all;
	G_OBJECT_CLASS (klass)->constructor = color_picker_widgets_picker_constructor;
	G_OBJECT_CLASS (klass)->finalize = color_picker_widgets_picker_finalize;
	color_picker_widgets_picker_signals[COLOR_PICKER_WIDGETS_PICKER_PICKED_SIGNAL] = g_signal_new ("picked", COLOR_PICKER_WIDGETS_TYPE_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_rgba_get_type ());
	color_picker_widgets_picker_signals[COLOR_PICKER_WIDGETS_PICKER_CANCELLED_SIGNAL] = g_signal_new ("cancelled", COLOR_PICKER_WIDGETS_TYPE_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	color_picker_widgets_picker_signals[COLOR_PICKER_WIDGETS_PICKER_MOVED_SIGNAL] = g_signal_new ("moved", COLOR_PICKER_WIDGETS_TYPE_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_rgba_get_type ());
}

static void
color_picker_widgets_picker_instance_init (ColorPickerWidgetsPicker * self,
                                           gpointer klass)
{
	self->priv = color_picker_widgets_picker_get_instance_private (self);
	memset (&self->priv->dark_border_color, 0, sizeof (GdkRGBA));
	memset (&self->priv->bright_border_color, 0, sizeof (GdkRGBA));
	self->priv->snapsize = 31;
	self->priv->min_zoomlevel = 2;
	self->priv->max_zoomlevel = 7;
	self->priv->zoomlevel = 3;
	self->priv->shadow_width = 15;
	self->priv->magnifier = NULL;
}

static void
color_picker_widgets_picker_finalize (GObject * obj)
{
	ColorPickerWidgetsPicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, COLOR_PICKER_WIDGETS_TYPE_PICKER, ColorPickerWidgetsPicker);
	_g_object_unref0 (self->priv->magnifier);
	G_OBJECT_CLASS (color_picker_widgets_picker_parent_class)->finalize (obj);
}

GType
color_picker_widgets_picker_get_type (void)
{
	static volatile gsize color_picker_widgets_picker_type_id__volatile = 0;
	if (g_once_init_enter (&color_picker_widgets_picker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ColorPickerWidgetsPickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) color_picker_widgets_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ColorPickerWidgetsPicker), 0, (GInstanceInitFunc) color_picker_widgets_picker_instance_init, NULL };
		GType color_picker_widgets_picker_type_id;
		color_picker_widgets_picker_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_COMPOSITED_WINDOW, "ColorPickerWidgetsPicker", &g_define_type_info, 0);
		ColorPickerWidgetsPicker_private_offset = g_type_add_instance_private (color_picker_widgets_picker_type_id, sizeof (ColorPickerWidgetsPickerPrivate));
		g_once_init_leave (&color_picker_widgets_picker_type_id__volatile, color_picker_widgets_picker_type_id);
	}
	return color_picker_widgets_picker_type_id__volatile;
}

